'use strict';

var glob = require('glob');

module.exports = function(grunt) {

    let allSource = glob.sync('**/*.js', { ignore: 'node_modules/**/*.js' }).join(' ');

    grunt.initConfig({

        exec: {
            precommit: {
                command: 'cp ' + __dirname + '/.build/pre-commit ' + __dirname + '/.git/hooks && chmod 755 ' + __dirname + '/.git/hooks/pre-commit'
            },
            lint: {
                command: 'eslint ' + allSource
            },
            loc: {
                command: 'sloc ' + allSource
            },
            npm: {
                command: 'rm -rf package-lock.json node_modules && npm i'
            }
        }
    });

    grunt.loadNpmTasks('grunt-exec');

    // Composite tasks
    grunt.registerTask('default', [ 'precommit', 'lint', 'loc' ]);

    // Singleton tasks
    grunt.registerTask('precommit', [ 'exec:precommit' ]);
    grunt.registerTask('lint', [ 'exec:lint' ]);
    grunt.registerTask('loc', [ 'exec:loc' ]);
    grunt.registerTask('npm', [ 'exec:npm' ]);
};
