## Functions

<dl>
<dt><a href="#validate">validate(artifacts, opts)</a> ⇒</dt>
<dd><p>Perform validation on the provided artifacts. This function handles schema validation and semantic validation.</p>
</dd>
</dl>

## Typedefs

<dl>
<dt><a href="#Response">Response</a> : <code>object</code></dt>
<dd></dd>
<dt><a href="#schema-validation">schema-validation</a> : <code>object</code></dt>
<dd></dd>
<dt><a href="#artifact">artifact</a> : <code>object</code></dt>
<dd></dd>
</dl>

<a name="validate"></a>

## validate(artifacts, opts) ⇒
Perform validation on the provided artifacts. This function handles schema validation and semantic validation.

**Kind**: global function
**Returns**: Promise<Response> that resolves to Response

| Param | Type | Description |
| --- | --- | --- |
| artifacts | <code>[Array.&lt;artifact&gt;](#artifact)</code> | to validate |
| opts | <code>object</code> |  |
| opts.productOnly | <code>boolean</code> | validate only provided product artifacts |
| opts.extensions | <code>boolean</code> | also validate schema extensions |

<a name="Response"></a>

## Response : <code>object</code>
**Kind**: global typedef
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| artifact | <code>[artifact](#artifact)</code> | that was validated |
| error | <code>Array.&lt;error&gt;</code> | any errors that were encountered |
| schema_validations | <code>[Array.&lt;schema-validation&gt;](#schema-validation)</code> | results |

<a name="schema-validation"></a>

## schema-validation : <code>object</code>
**Kind**: global typedef
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| title | <code>string</code> | the title of the schema valdation that was performed |
| path | <code>string</code> | Resolved path to product or swagger file. |
| error | <code>err</code> |  |
| type | <code>string</code> |  |
| status | <code>string</code> | valid or not_valid |

<a name="artifact"></a>

## artifact : <code>object</code>
**Kind**: global typedef
**Properties**

| Name | Type | Description |
| --- | --- | --- |
| type | <code>string</code> | `product` or `swagger`. |
| filePath | <code>string</code> | Resolved path to product or swagger file. |
| name | <code>string</code> |  |
| version | <code>string</code> |  |
| raw | <code>string</code> | contents of filePath |
| refs | <code>Artifacts</code> | if( type===product ) and referenced product.apis[$ref] exist. Those will also be loaded |
| err | <code>Error</code> | optional Error |
| data | <code>object</code> | js-yaml parsed raw content |

