'use strict';

var Promise = require('bluebird');
var fs = require('fs');
var g = require('strong-globalize')();
var yaml = require('js-yaml');
var validateObject = require('./validate-object');

module.exports = function(filename, validateExtension) {
    if (typeof validateExtension === 'undefined') {
        validateExtension = true;
    }
    var definition;
    try {
        definition = yaml.safeLoad(fs.readFileSync(filename, 'utf8'));
    } catch (err) {
        return Promise.reject(err);
    }
    if (!definition) {
        return Promise.reject(new Error(g.f('The API file %s is invalid.', filename)));
    }
    return validateObject(definition, filename, validateExtension);
};
