// Licensed Materials - Property of IBM
// 5725-Z22, 5725-Z63, 5725-U33, 5725-Z63
// (C) Copyright IBM Corporation 2016, 2017
// All Rights Reserved.
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

'use strict';

var g = require('strong-globalize')();

module.exports = function(str) {
    return detectTabsIndentation(str);
};

function detectTabsIndentation(file) {
    var errorMsg = 'Invalid indent character "tab" lines: [%s]';
    var ln = [];
    var lines = file.split(/\n/g);

    for (var i = 0; i < lines.length; i++) {
        var line = lines[i];
        if (line) {
            var indent_regex = /^(?:( )+|\t+)/;
            var matches = line.match(indent_regex);

            if (matches && !matches[1]) {
                ln.push(i + 1);
            }
        }
    }
    if (ln.length > 0) {
        var err = new Error(g.f(errorMsg, ln));
        err.type = 'tabs-indentation';
        err.lines = ln;
        throw err;
    }
}
